package org.apache.bcel.generic;

import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantLong;

/* loaded from: org_apache_bcel_generic.jar:org/apache/bcel/generic/LDC2_W.class */
public class LDC2_W extends CPInstruction implements PushInstruction {
    /* JADX INFO: Access modifiers changed from: package-private */
    public LDC2_W() {
    }

    public LDC2_W(int index) {
        super((short) 20, index);
    }

    @Override // org.apache.bcel.generic.Instruction
    public void accept(Visitor v) {
        v.visitStackProducer(this);
        v.visitPushInstruction(this);
        v.visitTypedInstruction(this);
        v.visitCPInstruction(this);
        v.visitLDC2_W(this);
    }

    @Override // org.apache.bcel.generic.CPInstruction, org.apache.bcel.generic.TypedInstruction
    public Type getType(ConstantPoolGen cpg) {
        switch (cpg.getConstantPool().getConstant(super.getIndex()).getTag()) {
            case 5:
                return Type.LONG;
            case 6:
                return Type.DOUBLE;
            default:
                throw new IllegalArgumentException("Unknown constant type " + ((int) super.getOpcode()));
        }
    }

    public Number getValue(ConstantPoolGen cpg) {
        ConstantLong constant = cpg.getConstantPool().getConstant(super.getIndex());
        switch (constant.getTag()) {
            case 5:
                return Long.valueOf(constant.getBytes());
            case 6:
                return Double.valueOf(((ConstantDouble) constant).getBytes());
            default:
                throw new IllegalArgumentException("Unknown or invalid constant type at " + super.getIndex());
        }
    }
}
